#!/bin/bash

#########
# oradebug module installer
# Author: László Tóth, Ferenc Spala
########

# The installation folder of metasploit, e.g. /pentest/exploit/framework/
METASPLOIT_DIR=""
CONFIG_FILE=".installdir"

if [ -f "$CONFIG_FILE" ]; then
  METASPLOIT_DIR=`cat "$CONFIG_FILE"`
fi

if [ "$METASPLOIT_DIR" == "" ]; then
  R=""
  while [ "$R" == "" ]
  do
    echo -n "Please enter the root directory of your Metasploit installation: "
    read R
    if [ ! -f "$R"/msfconsole ]; then
      R=""
    fi
  done

  METASPLOIT_DIR="$R/"
fi
echo "$METASPLOIT_DIR" > "$CONFIG_FILE"

if [ ! -d $HOME/.msf4/modules/auxiliary ]; then
  mkdir $HOME/.msf4/modules/auxiliary
fi

cp tnspoison.rb $HOME/.msf4/modules/auxiliary/
cp longpackets.rb $METASPLOIT_DIR/lib/msf/core/exploit/
cp oracletns.rb $METASPLOIT_DIR/lib/msf/core/exploit/
cp oracrypto.rb $METASPLOIT_DIR/lib/msf/core/exploit/

echo '#' >> $METASPLOIT_DIR/lib/msf/core/exploit/mixins.rb
echo '#' Mixins for tnspoison and oradebug modules >> $METASPLOIT_DIR/lib/msf/core/exploit/mixins.rb
echo '#' >> $METASPLOIT_DIR/lib/msf/core/exploit/mixins.rb
echo require "'msf/core/exploit/longpackets'" >> $METASPLOIT_DIR/lib/msf/core/exploit/mixins.rb
echo require "'msf/core/exploit/oracrypto'" >> $METASPLOIT_DIR/lib/msf/core/exploit/mixins.rb
echo require "'msf/core/exploit/oracletns'" >> $METASPLOIT_DIR/lib/msf/core/exploit/mixins.rb

